<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('FactoryModeling.ProductUnit.dialogNameLabel')" prop="name">
        <el-input
          v-model="formData.name"
          :placeholder="t('FactoryModeling.ProductUnit.dialogNamePlaceholder')"
          :disabled="formType === 'update'"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductUnit.dialogPrimaryFlagLabel')" prop="primaryFlag">
        <el-radio-group v-model="formData.primaryFlag">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.PRIMARY_FLAG)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item
        :label="t('FactoryModeling.ProductUnit.dialogPrimaryUnitLabel')"
        v-if="formData.primaryFlag === 'N'"
        prop="primaryId"
      >
        <el-select
          v-model="formData.primaryId"
          clearable
          filterable
          :placeholder="t('FactoryModeling.ProductUnit.dialogPrimaryUnitPlaceholder')"
        >
          <el-option
            v-for="item in unitList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item
        :label="t('FactoryModeling.ProductUnit.dialogChangeRateLabel')"
        v-if="formData.primaryFlag === 'N'"
        prop="changeRate"
      >
        <el-input-number
          v-model="formData.changeRate"
          :step="0.1"
          :min="0.00"
          :placeholder="t('FactoryModeling.ProductUnit.dialogChangeRatePlaceholder')"
          class="!w-full"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductUnit.dialogStatusLabel')" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.COMMON_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">
        {{ t('FactoryModeling.ProductUnit.dialogSubmitButton') }}
      </el-button>
      <el-button @click="dialogVisible = false">
        {{ t('FactoryModeling.ProductUnit.dialogCancelButton') }}
      </el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ProductUnitApi,ProductUnitVO } from '@/api/erp/product/unit'
import { DICT_TYPE, getIntDictOptions, getStrDictOptions } from '@/utils/dict'
import { CommonStatusEnum } from '@/utils/constants'

/** ERP 产品单位表单 */
defineOptions({ name: 'ProductUnitForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const unitList = ref<ProductUnitVO[]>([]) // 列表
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  status: undefined,
  primaryFlag: undefined,
  primaryId: undefined,
  changeRate: undefined,
})
const formRules = reactive({
  name: [
    {
      required: true,
      message: t('FactoryModeling.ProductUnit.validatorNameRequired'),
      trigger: 'blur'
    }
  ],
  status: [
    {
      required: true,
      message: t('FactoryModeling.ProductUnit.validatorStatusRequired'),
      trigger: 'blur'
    }
  ],
  primaryFlag: [
    {
      required: true,
      message: t('FactoryModeling.ProductUnit.validatorPrimaryFlagRequired'),
      trigger: 'blur'
    }
  ]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ProductUnitApi.getProductUnit(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ProductUnitVO
    if (formType.value === 'create') {
      await ProductUnitApi.createProductUnit(data)
      message.success(t('common.createSuccess'))
    } else {
      await ProductUnitApi.updateProductUnit(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
    unitList.value = await ProductUnitApi.getProductUnitListByFlag()
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    primaryFlag: 'N',
  primaryId: undefined,
  changeRate: undefined,
    status: CommonStatusEnum.ENABLE
  }
  formRef.value?.resetFields()
}

/** 初始化 **/
onMounted(async () => {
  unitList.value = await ProductUnitApi.getProductUnitListByFlag()
})
</script>
